/*
 * This work is licensed under a Creative Commons 
 * Attribution-Noncommercial-Share Alike 3.0 United States License.
 * 
 *    http://creativecommons.org/licenses/by-nc-sa/3.0/us/
 * 
 * You are free:
 * 
 *    to Share - to copy, distribute, display, and perform the work
 *    to Remix - to make derivative works
 * 
 * Under the following conditions:
 * 
 *    Attribution. You must attribute the work in the manner specified by the
 *    author or licensor (but not in any way that suggests that they endorse you
 *    or your use of the work).
 * 
 *    Noncommercial. You may not use this work for commercial purposes.
 * 
 *    Share Alike. If you alter, transform, or build upon this work, you may
 *    distribute the resulting work only under the same or similar license to
 *    this one.
 * 
 * For any reuse or distribution, you must make clear to others the license
 * terms of this work. The best way to do this is by including this header.
 * 
 * Any of the above conditions can be waived if you get permission from the
 * copyright holder.
 * 
 * Apart from the remix rights granted under this license, nothing in this
 * license impairs or restricts the author's moral rights.
 */


/** 
 * @file 
 *
 * @author Joseph Schlecht
 *
 * @cclicense
 *
 * @brief Declarations for image block utility functions.
 */


#ifndef IMGBLOCK_UTIL_H
#define IMGBLOCK_UTIL_H


#include <jwsc/config.h>

#include <stdlib.h>

#include "jwsc/base/error.h"
#include "jwsc/imgblock/imgblock.h"


#ifdef __cplusplus
namespace jwsc {
extern "C" {
#endif


/** 
 * @name down_sample_imgblock
 *
 * Down samples an image block.
 * @{
 */

/** @brief Down samples a single precision image block. */
Error* down_sample_imgblock_f
(
    Imgblock_f**      img_out, 
    const Imgblock_f* img_in, 
    float             img_factor,
    float             row_factor,
    float             col_factor
);


#ifdef __cplusplus
}
}
#endif


#endif
