/*
 * This work is licensed under a Creative Commons 
 * Attribution-Noncommercial-Share Alike 3.0 United States License.
 * 
 *    http://creativecommons.org/licenses/by-nc-sa/3.0/us/
 * 
 * You are free:
 * 
 *    to Share - to copy, distribute, display, and perform the work
 *    to Remix - to make derivative works
 * 
 * Under the following conditions:
 * 
 *    Attribution. You must attribute the work in the manner specified by the
 *    author or licensor (but not in any way that suggests that they endorse you
 *    or your use of the work).
 * 
 *    Noncommercial. You may not use this work for commercial purposes.
 * 
 *    Share Alike. If you alter, transform, or build upon this work, you may
 *    distribute the resulting work only under the same or similar license to
 *    this one.
 * 
 * For any reuse or distribution, you must make clear to others the license
 * terms of this work. The best way to do this is by including this header.
 * 
 * Any of the above conditions can be waived if you get permission from the
 * copyright holder.
 * 
 * Apart from the remix rights granted under this license, nothing in this
 * license impairs or restricts the author's moral rights.
 */


/**
 * @file
 *
 * @author Joseph Schlecht
 *
 * @cclicense
 *
 * @brief Exact and approximate mathematical constants.
 *
 * This file should be replaced by an autoconf test that sets a -D define in
 * the config.h.
 */


#ifndef CONSTANTS_H
#define CONSTANTS_H


/** @brief Pi/8. */
#define  JWSC_PI_8  0.39269908169872f


/** @brief Pi/4. */
#define  JWSC_PI_4  0.78539816339744f


/** @brief Pi/2. */
#define  JWSC_PI_2  1.57079632679488f


/** @brief Pi. */
#define  JWSC_PI  3.14159265358979f


/** @brief 2*Pi. */
#define  JWSC_2_PI  6.28318530717958f


/** @brief Scalar to convert degrees to radians. */
#define  JWSC_DEG_TO_RAD   0.01745329251994


/** @brief Scalar to convert radians to degrees. */
#define  JWSC_RAD_TO_DEG  57.29577951308232


#endif
