/*
 * This work is licensed under a Creative Commons 
 * Attribution-Noncommercial-Share Alike 3.0 United States License.
 * 
 *    http://creativecommons.org/licenses/by-nc-sa/3.0/us/
 * 
 * You are free:
 * 
 *    to Share - to copy, distribute, display, and perform the work
 *    to Remix - to make derivative works
 * 
 * Under the following conditions:
 * 
 *    Attribution. You must attribute the work in the manner specified by the
 *    author or licensor (but not in any way that suggests that they endorse you
 *    or your use of the work).
 * 
 *    Noncommercial. You may not use this work for commercial purposes.
 * 
 *    Share Alike. If you alter, transform, or build upon this work, you may
 *    distribute the resulting work only under the same or similar license to
 *    this one.
 * 
 * For any reuse or distribution, you must make clear to others the license
 * terms of this work. The best way to do this is by including this header.
 * 
 * Any of the above conditions can be waived if you get permission from the
 * copyright holder.
 * 
 * Apart from the remix rights granted under this license, nothing in this
 * license impairs or restricts the author's moral rights.
 */


#include <jwsc/config.h>

#include <stdlib.h>
#include <stdio.h>
#include <assert.h>

#include "jwsc/math/blas.h"


int main(int argc, char** argv)
{
    double *v1, *v2;
    double *m1;
    int k,n;
    int i,e;

    k = 1;
    n = 10;
    srand((unsigned int)384759283);

    assert((v1 = malloc(n*sizeof(double))));
    assert((v2 = malloc(n*sizeof(double))));
    assert((m1 = malloc(n*n*sizeof(double))));

        for (e = 0; e < n; e++)
        {
            v1[ e ] = (double)rand() / (double)RAND_MAX;
            v2[ e ] = (double)rand() / (double)RAND_MAX;
        }

        for (e = 0; e < n*n; e++)
        {
            m1[ e ] = (double)rand() / (double)RAND_MAX;
        }

    for (i = 0; i < k; i++)
    {
#if defined JWSC_HAVE_BLAS || defined JWSC_HAVE_ACCELERATE
        blas_sdot(n, v1, 1, v2, 1);
        /*blas_daxpy(n, 1.0f, v1, 1, v2, 1);*/
        /*blas_dgemv('N', n, n, 1, m1, n, v1, 1, 0, v2, 1);*/
#endif
    }

    return EXIT_SUCCESS;
}
