/*
 * This work is licensed under a Creative Commons 
 * Attribution-Noncommercial-Share Alike 3.0 United States License.
 * 
 *    http://creativecommons.org/licenses/by-nc-sa/3.0/us/
 * 
 * You are free:
 * 
 *    to Share - to copy, distribute, display, and perform the work
 *    to Remix - to make derivative works
 * 
 * Under the following conditions:
 * 
 *    Attribution. You must attribute the work in the manner specified by the
 *    author or licensor (but not in any way that suggests that they endorse you
 *    or your use of the work).
 * 
 *    Noncommercial. You may not use this work for commercial purposes.
 * 
 *    Share Alike. If you alter, transform, or build upon this work, you may
 *    distribute the resulting work only under the same or similar license to
 *    this one.
 * 
 * For any reuse or distribution, you must make clear to others the license
 * terms of this work. The best way to do this is by including this header.
 * 
 * Any of the above conditions can be waived if you get permission from the
 * copyright holder.
 * 
 * Apart from the remix rights granted under this license, nothing in this
 * license impairs or restricts the author's moral rights.
 */


#include <stdlib.h>
#include <stdio.h>
#include <assert.h>
#include <math.h>
#include <inttypes.h>

#include "jwsc/base/error.h"
#include "jwsc/vector/vector.h"


int main(int argc, char** argv)
{
    uint32_t num_elts;
    uint32_t elt;

    int64_t min, max;
    int64_t val;
    Vector_i64* v_1 = NULL;
    Vector_i64* v_2 = NULL;
    Vector_i64* v_3 = NULL;

    Error* e;

    num_elts = 10;

    create_zero_vector_i64(&v_1, num_elts);
    for (elt = 0; elt < num_elts; elt++)
    {
#ifdef JWSC_HAVE_64_BIT_LONG_INT
        fprintf(stdout, "%lu ", v_1->elts[ elt ]);
#else
        fprintf(stdout, "%llu ", v_1->elts[ elt ]);
#endif
    }
    fprintf(stdout, "\n");

    min = 0;
    max = 255;
    create_random_vector_i64(&v_2, num_elts, min, max);
    for (elt = 0; elt < num_elts; elt++)
    {
#ifdef JWSC_HAVE_64_BIT_LONG_INT
        fprintf(stdout, "%lu ", v_2->elts[ elt ]);
#else
        fprintf(stdout, "%llu ", v_2->elts[ elt ]);
#endif
    }
    fprintf(stdout, "\n");

    create_random_vector_i64(&v_2, num_elts, min, max);
    for (elt = 0; elt < num_elts; elt++)
    {
#ifdef JWSC_HAVE_64_BIT_LONG_INT
        fprintf(stdout, "%lu ", v_2->elts[ elt ]);
#else
        fprintf(stdout, "%llu ", v_2->elts[ elt ]);
#endif
    }
    fprintf(stdout, "\n");

    if ((e = copy_vector_section_i64(&v_3, v_2, 3, 6)) != NULL)
    {
        print_error_exit("vector-test", e);
    }
    for (elt = 0; elt < v_3->num_elts ; elt++)
    {
#ifdef JWSC_HAVE_64_BIT_LONG_INT
        fprintf(stdout, "%lu ", v_3->elts[ elt ]);
#else
        fprintf(stdout, "%llu ", v_3->elts[ elt ]);
#endif
    }
    fprintf(stdout, "\n");

    val = v_3->elts[ 2 ];
#ifdef JWSC_HAVE_64_BIT_LONG_INT
    fprintf(stdout, "%lu\n", val);
#else
    fprintf(stdout, "%llu\n", val);
#endif

    val = 666;
    v_3->elts[ 2 ] = val;
    for (elt = 0; elt < v_3->num_elts ; elt++)
    {
#ifdef JWSC_HAVE_64_BIT_LONG_INT
        fprintf(stdout, "%lu ", v_3->elts[ elt ]);
#else
        fprintf(stdout, "%llu ", v_3->elts[ elt ]);
#endif
    }
    fprintf(stdout, "\n");

    free_vector_i64(v_1);
    free_vector_i64(v_2);
    free_vector_i64(v_3);

    return EXIT_SUCCESS;
}
